//global variable

int[] ballPos;
int[] ballSpeed;
int[] leftPaddlePos;
int[] rightPaddlePos;
int[] paddleSize;
int leftPlayerScore;
int rightPlayerScore;
int ballSize;

void setup()
{
  size(800, 600);

  ballPos = new int[] {
    400, 300
  };
  ballSpeed = new int[] {
    2, 2
  };
  leftPaddlePos = new int[] {
    40, 40
  };
  rightPaddlePos = new int[] {
    740, 40
  };
  paddleSize = new int[] {
    20, 80
  };
  leftPlayerScore = 0;
  rightPlayerScore = 0;
  ballSize = 20;
}

void draw()
{
  background(0, 0, 0);
  fill(255, 255, 255);
  noStroke();

  paddles();

  ball();
  
  score();
}

void paddles()
{
  rect(leftPaddlePos[0], leftPaddlePos[1], paddleSize[0], paddleSize[1]);
  rect(rightPaddlePos[0], rightPaddlePos[1], paddleSize[0], paddleSize[1]);
  
  if(keyPressed){
    if(key == 'q'){
      leftPaddlePos[1] -= 10;
    }
    if(key == 'a'){
      leftPaddlePos[1] += 10;
    }
    if(key == 'o'){
      rightPaddlePos[1] -= 10;
    }
    if(key == 'l'){
      rightPaddlePos[1] += 10;
    }
  }
  
  //collision with walls
  if(leftPaddlePos[1] > 520){
    leftPaddlePos[1] = 520;
  }
  if(leftPaddlePos[1] < 0){
    leftPaddlePos[1] = 0;
  }
  if(rightPaddlePos[1] > 520){
    rightPaddlePos[1] = 520;
  }
  if(rightPaddlePos[1] < 0){
    rightPaddlePos[1] = 0;
  }
}

void ball()
{
  ellipse(ballPos[0], ballPos[1], 20, 20);
  ballPos[0] += ballSpeed[0];
  ballPos[1] += ballSpeed[1];

  //collision left paddle
  if (ballPos[0] == 66 &&
    ballPos[1] > leftPaddlePos[1] &&
    leftPaddlePos[1] + paddleSize[1] > ballPos[1])
  {
    ballSpeed[0] *= -1;
  }

  //collision right paddle
  if (ballPos[0] == 734 &&
    ballPos[1] > rightPaddlePos[1] &&
    rightPaddlePos[1] + paddleSize[1] > ballPos[1])
  {
    ballSpeed[0] *= -1;
  }
  
  //collision with walls
  if(ballPos[1] >= 590){
    ballSpeed[1] *= -1;
  }
  if(ballPos[1] < 10){
    ballSpeed[1] *= -1;
  }
  
  //left the screen
  if(ballPos[0] < 0){
    //right player scored
    rightPlayerScore++;
    ballPos[0] = 400;
  }
  if(ballPos[0] > 800){
    //left player scored
    leftPlayerScore++;
    ballPos[0] = 400;
  }
}

void score()
{
  textAlign(CENTER);
  textSize(80);
  text(leftPlayerScore, 350, 80);
  text(rightPlayerScore, 450, 80);
}
